Merge branch 'nd/format-patch-stat-width'
[git] / git-rebase--interactive.sh
1 # This shell script fragment is sourced by git-rebase to implement
2 # its interactive mode.  "git rebase --interactive" makes it easy
3 # to fix up commits in the middle of a series and rearrange commits.
4 #
5 # Copyright (c) 2006 Johannes E. Schindelin
6 #
7 # The original idea comes from Eric W. Biederman, in
8 # https://public-inbox.org/git/m1odwkyuf5.fsf_-_@ebiederm.dsl.xmission.com/
9 #
10 # The file containing rebase commands, comments, and empty lines.
11 # This file is created by "git rebase -i" then edited by the user.  As
12 # the lines are processed, they are removed from the front of this
13 # file and written to the tail of $done.
14 todo="$state_dir"/git-rebase-todo
15
16 # The rebase command lines that have already been processed.  A line
17 # is moved here when it is first handled, before any associated user
18 # actions.
19 done="$state_dir"/done
20
21 # The commit message that is planned to be used for any changes that
22 # need to be committed following a user interaction.
23 msg="$state_dir"/message
24
25 # The file into which is accumulated the suggested commit message for
26 # squash/fixup commands.  When the first of a series of squash/fixups
27 # is seen, the file is created and the commit message from the
28 # previous commit and from the first squash/fixup commit are written
29 # to it.  The commit message for each subsequent squash/fixup commit
30 # is appended to the file as it is processed.
31 #
32 # The first line of the file is of the form
33 #     # This is a combination of $count commits.
34 # where $count is the number of commits whose messages have been
35 # written to the file so far (including the initial "pick" commit).
36 # Each time that a commit message is processed, this line is read and
37 # updated.  It is deleted just before the combined commit is made.
38 squash_msg="$state_dir"/message-squash
39
40 # If the current series of squash/fixups has not yet included a squash
41 # command, then this file exists and holds the commit message of the
42 # original "pick" commit.  (If the series ends without a "squash"
43 # command, then this can be used as the commit message of the combined
44 # commit without opening the editor.)
45 fixup_msg="$state_dir"/message-fixup
46
47 # $rewritten is the name of a directory containing files for each
48 # commit that is reachable by at least one merge base of $head and
49 # $upstream. They are not necessarily rewritten, but their children
50 # might be.  This ensures that commits on merged, but otherwise
51 # unrelated side branches are left alone. (Think "X" in the man page's
52 # example.)
53 rewritten="$state_dir"/rewritten
54
55 dropped="$state_dir"/dropped
56
57 end="$state_dir"/end
58 msgnum="$state_dir"/msgnum
59
60 # A script to set the GIT_AUTHOR_NAME, GIT_AUTHOR_EMAIL, and
61 # GIT_AUTHOR_DATE that will be used for the commit that is currently
62 # being rebased.
63 author_script="$state_dir"/author-script
64
65 # When an "edit" rebase command is being processed, the SHA1 of the
66 # commit to be edited is recorded in this file.  When "git rebase
67 # --continue" is executed, if there are any staged changes then they
68 # will be amended to the HEAD commit, but only provided the HEAD
69 # commit is still the commit to be edited.  When any other rebase
70 # command is processed, this file is deleted.
71 amend="$state_dir"/amend
72
73 # For the post-rewrite hook, we make a list of rewritten commits and
74 # their new sha1s.  The rewritten-pending list keeps the sha1s of
75 # commits that have been processed, but not committed yet,
76 # e.g. because they are waiting for a 'squash' command.
77 rewritten_list="$state_dir"/rewritten-list
78 rewritten_pending="$state_dir"/rewritten-pending
79
80 # Work around Git for Windows' Bash whose "read" does not strip CRLF
81 # and leaves CR at the end instead.
82 cr=$(printf "\015")
83
84 strategy_args=${strategy:+--strategy=$strategy}
85 test -n "$strategy_opts" &&
86 eval '
87         for strategy_opt in '"$strategy_opts"'
88         do
89                 strategy_args="$strategy_args -X$(git rev-parse --sq-quote "${strategy_opt#--}")"
90         done
91 '
92
93 GIT_CHERRY_PICK_HELP="$resolvemsg"
94 export GIT_CHERRY_PICK_HELP
95
96 comment_char=$(git config --get core.commentchar 2>/dev/null)
97 case "$comment_char" in
98 '' | auto)
99         comment_char="#"
100         ;;
101 ?)
102         ;;
103 *)
104         comment_char=$(echo "$comment_char" | cut -c1)
105         ;;
106 esac
107
108 warn () {
109         printf '%s\n' "$*" >&2
110 }
111
112 # Output the commit message for the specified commit.
113 commit_message () {
114         git cat-file commit "$1" | sed "1,/^$/d"
115 }
116
117 orig_reflog_action="$GIT_REFLOG_ACTION"
118
119 comment_for_reflog () {
120         case "$orig_reflog_action" in
121         ''|rebase*)
122                 GIT_REFLOG_ACTION="rebase -i ($1)"
123                 export GIT_REFLOG_ACTION
124                 ;;
125         esac
126 }
127
128 last_count=
129 mark_action_done () {
130         sed -e 1q < "$todo" >> "$done"
131         sed -e 1d < "$todo" >> "$todo".new
132         mv -f "$todo".new "$todo"
133         new_count=$(( $(git stripspace --strip-comments <"$done" | wc -l) ))
134         echo $new_count >"$msgnum"
135         total=$(($new_count + $(git stripspace --strip-comments <"$todo" | wc -l)))
136         echo $total >"$end"
137         if test "$last_count" != "$new_count"
138         then
139                 last_count=$new_count
140                 eval_gettext "Rebasing (\$new_count/\$total)"; printf "\r"
141                 test -z "$verbose" || echo
142         fi
143 }
144
145 # Put the last action marked done at the beginning of the todo list
146 # again. If there has not been an action marked done yet, leave the list of
147 # items on the todo list unchanged.
148 reschedule_last_action () {
149         tail -n 1 "$done" | cat - "$todo" >"$todo".new
150         sed -e \$d <"$done" >"$done".new
151         mv -f "$todo".new "$todo"
152         mv -f "$done".new "$done"
153 }
154
155 append_todo_help () {
156         gettext "
157 Commands:
158 p, pick = use commit
159 r, reword = use commit, but edit the commit message
160 e, edit = use commit, but stop for amending
161 s, squash = use commit, but meld into previous commit
162 f, fixup = like \"squash\", but discard this commit's log message
163 x, exec = run command (the rest of the line) using shell
164 d, drop = remove commit
165
166 These lines can be re-ordered; they are executed from top to bottom.
167 " | git stripspace --comment-lines >>"$todo"
168
169         if test $(get_missing_commit_check_level) = error
170         then
171                 gettext "
172 Do not remove any line. Use 'drop' explicitly to remove a commit.
173 " | git stripspace --comment-lines >>"$todo"
174         else
175                 gettext "
176 If you remove a line here THAT COMMIT WILL BE LOST.
177 " | git stripspace --comment-lines >>"$todo"
178         fi
179 }
180
181 make_patch () {
182         sha1_and_parents="$(git rev-list --parents -1 "$1")"
183         case "$sha1_and_parents" in
184         ?*' '?*' '?*)
185                 git diff --cc $sha1_and_parents
186                 ;;
187         ?*' '?*)
188                 git diff-tree -p "$1^!"
189                 ;;
190         *)
191                 echo "Root commit"
192                 ;;
193         esac > "$state_dir"/patch
194         test -f "$msg" ||
195                 commit_message "$1" > "$msg"
196         test -f "$author_script" ||
197                 get_author_ident_from_commit "$1" > "$author_script"
198 }
199
200 die_with_patch () {
201         echo "$1" > "$state_dir"/stopped-sha
202         make_patch "$1"
203         die "$2"
204 }
205
206 exit_with_patch () {
207         echo "$1" > "$state_dir"/stopped-sha
208         make_patch $1
209         git rev-parse --verify HEAD > "$amend"
210         gpg_sign_opt_quoted=${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")}
211         warn "$(eval_gettext "\
212 You can amend the commit now, with
213
214         git commit --amend \$gpg_sign_opt_quoted
215
216 Once you are satisfied with your changes, run
217
218         git rebase --continue")"
219         warn
220         exit $2
221 }
222
223 die_abort () {
224         apply_autostash
225         rm -rf "$state_dir"
226         die "$1"
227 }
228
229 has_action () {
230         test -n "$(git stripspace --strip-comments <"$1")"
231 }
232
233 is_empty_commit() {
234         tree=$(git rev-parse -q --verify "$1"^{tree} 2>/dev/null) || {
235                 sha1=$1
236                 die "$(eval_gettext "\$sha1: not a commit that can be picked")"
237         }
238         ptree=$(git rev-parse -q --verify "$1"^^{tree} 2>/dev/null) ||
239                 ptree=4b825dc642cb6eb9a060e54bf8d69288fbee4904
240         test "$tree" = "$ptree"
241 }
242
243 is_merge_commit()
244 {
245         git rev-parse --verify --quiet "$1"^2 >/dev/null 2>&1
246 }
247
248 # Run command with GIT_AUTHOR_NAME, GIT_AUTHOR_EMAIL, and
249 # GIT_AUTHOR_DATE exported from the current environment.
250 do_with_author () {
251         (
252                 export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
253                 "$@"
254         )
255 }
256
257 git_sequence_editor () {
258         if test -z "$GIT_SEQUENCE_EDITOR"
259         then
260                 GIT_SEQUENCE_EDITOR="$(git config sequence.editor)"
261                 if [ -z "$GIT_SEQUENCE_EDITOR" ]
262                 then
263                         GIT_SEQUENCE_EDITOR="$(git var GIT_EDITOR)" || return $?
264                 fi
265         fi
266
267         eval "$GIT_SEQUENCE_EDITOR" '"$@"'
268 }
269
270 pick_one () {
271         ff=--ff
272
273         case "$1" in -n) sha1=$2; ff= ;; *) sha1=$1 ;; esac
274         case "$force_rebase" in '') ;; ?*) ff= ;; esac
275         output git rev-parse --verify $sha1 || die "$(eval_gettext "Invalid commit name: \$sha1")"
276
277         if is_empty_commit "$sha1"
278         then
279                 empty_args="--allow-empty"
280         fi
281
282         test -d "$rewritten" &&
283                 pick_one_preserving_merges "$@" && return
284         output eval git cherry-pick $allow_rerere_autoupdate \
285                         ${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")} \
286                         "$strategy_args" $empty_args $ff "$@"
287
288         # If cherry-pick dies it leaves the to-be-picked commit unrecorded. Reschedule
289         # previous task so this commit is not lost.
290         ret=$?
291         case "$ret" in [01]) ;; *) reschedule_last_action ;; esac
292         return $ret
293 }
294
295 pick_one_preserving_merges () {
296         fast_forward=t
297         case "$1" in
298         -n)
299                 fast_forward=f
300                 sha1=$2
301                 ;;
302         *)
303                 sha1=$1
304                 ;;
305         esac
306         sha1=$(git rev-parse $sha1)
307
308         if test -f "$state_dir"/current-commit
309         then
310                 if test "$fast_forward" = t
311                 then
312                         while read current_commit
313                         do
314                                 git rev-parse HEAD > "$rewritten"/$current_commit
315                         done <"$state_dir"/current-commit
316                         rm "$state_dir"/current-commit ||
317                                 die "$(gettext "Cannot write current commit's replacement sha1")"
318                 fi
319         fi
320
321         echo $sha1 >> "$state_dir"/current-commit
322
323         # rewrite parents; if none were rewritten, we can fast-forward.
324         new_parents=
325         pend=" $(git rev-list --parents -1 $sha1 | cut -d' ' -s -f2-)"
326         if test "$pend" = " "
327         then
328                 pend=" root"
329         fi
330         while [ "$pend" != "" ]
331         do
332                 p=$(expr "$pend" : ' \([^ ]*\)')
333                 pend="${pend# $p}"
334
335                 if test -f "$rewritten"/$p
336                 then
337                         new_p=$(cat "$rewritten"/$p)
338
339                         # If the todo reordered commits, and our parent is marked for
340                         # rewriting, but hasn't been gotten to yet, assume the user meant to
341                         # drop it on top of the current HEAD
342                         if test -z "$new_p"
343                         then
344                                 new_p=$(git rev-parse HEAD)
345                         fi
346
347                         test $p != $new_p && fast_forward=f
348                         case "$new_parents" in
349                         *$new_p*)
350                                 ;; # do nothing; that parent is already there
351                         *)
352                                 new_parents="$new_parents $new_p"
353                                 ;;
354                         esac
355                 else
356                         if test -f "$dropped"/$p
357                         then
358                                 fast_forward=f
359                                 replacement="$(cat "$dropped"/$p)"
360                                 test -z "$replacement" && replacement=root
361                                 pend=" $replacement$pend"
362                         else
363                                 new_parents="$new_parents $p"
364                         fi
365                 fi
366         done
367         case $fast_forward in
368         t)
369                 output warn "$(eval_gettext "Fast-forward to \$sha1")"
370                 output git reset --hard $sha1 ||
371                         die "$(eval_gettext "Cannot fast-forward to \$sha1")"
372                 ;;
373         f)
374                 first_parent=$(expr "$new_parents" : ' \([^ ]*\)')
375
376                 if [ "$1" != "-n" ]
377                 then
378                         # detach HEAD to current parent
379                         output git checkout $first_parent 2> /dev/null ||
380                                 die "$(eval_gettext "Cannot move HEAD to \$first_parent")"
381                 fi
382
383                 case "$new_parents" in
384                 ' '*' '*)
385                         test "a$1" = a-n && die "$(eval_gettext "Refusing to squash a merge: \$sha1")"
386
387                         # redo merge
388                         author_script_content=$(get_author_ident_from_commit $sha1)
389                         eval "$author_script_content"
390                         msg_content="$(commit_message $sha1)"
391                         # No point in merging the first parent, that's HEAD
392                         new_parents=${new_parents# $first_parent}
393                         merge_args="--no-log --no-ff"
394                         if ! do_with_author output eval \
395                                 git merge ${gpg_sign_opt:+$(git rev-parse \
396                                         --sq-quote "$gpg_sign_opt")} \
397                                 $allow_rerere_autoupdate "$merge_args" \
398                                 "$strategy_args" \
399                                 -m $(git rev-parse --sq-quote "$msg_content") \
400                                 "$new_parents"
401                         then
402                                 printf "%s\n" "$msg_content" > "$GIT_DIR"/MERGE_MSG
403                                 die_with_patch $sha1 "$(eval_gettext "Error redoing merge \$sha1")"
404                         fi
405                         echo "$sha1 $(git rev-parse HEAD^0)" >> "$rewritten_list"
406                         ;;
407                 *)
408                         output eval git cherry-pick $allow_rerere_autoupdate \
409                                 ${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")} \
410                                 "$strategy_args" "$@" ||
411                                 die_with_patch $sha1 "$(eval_gettext "Could not pick \$sha1")"
412                         ;;
413                 esac
414                 ;;
415         esac
416 }
417
418 this_nth_commit_message () {
419         n=$1
420         eval_gettext "This is the commit message #\${n}:"
421 }
422
423 skip_nth_commit_message () {
424         n=$1
425         eval_gettext "The commit message #\${n} will be skipped:"
426 }
427
428 update_squash_messages () {
429         if test -f "$squash_msg"; then
430                 mv "$squash_msg" "$squash_msg".bak || exit
431                 count=$(($(sed -n \
432                         -e "1s/^$comment_char[^0-9]*\([0-9][0-9]*\).*/\1/p" \
433                         -e "q" < "$squash_msg".bak)+1))
434                 {
435                         printf '%s\n' "$comment_char $(eval_ngettext \
436                                 "This is a combination of \$count commit." \
437                                 "This is a combination of \$count commits." \
438                                 $count)"
439                         sed -e 1d -e '2,/^./{
440                                 /^$/d
441                         }' <"$squash_msg".bak
442                 } >"$squash_msg"
443         else
444                 commit_message HEAD >"$fixup_msg" ||
445                 die "$(eval_gettext "Cannot write \$fixup_msg")"
446                 count=2
447                 {
448                         printf '%s\n' "$comment_char $(gettext "This is a combination of 2 commits.")"
449                         printf '%s\n' "$comment_char $(gettext "This is the 1st commit message:")"
450                         echo
451                         cat "$fixup_msg"
452                 } >"$squash_msg"
453         fi
454         case $1 in
455         squash)
456                 rm -f "$fixup_msg"
457                 echo
458                 printf '%s\n' "$comment_char $(this_nth_commit_message $count)"
459                 echo
460                 commit_message $2
461                 ;;
462         fixup)
463                 echo
464                 printf '%s\n' "$comment_char $(skip_nth_commit_message $count)"
465                 echo
466                 # Change the space after the comment character to TAB:
467                 commit_message $2 | git stripspace --comment-lines | sed -e 's/ /       /'
468                 ;;
469         esac >>"$squash_msg"
470 }
471
472 peek_next_command () {
473         git stripspace --strip-comments <"$todo" | sed -n -e 's/ .*//p' -e q
474 }
475
476 # A squash/fixup has failed.  Prepare the long version of the squash
477 # commit message, then die_with_patch.  This code path requires the
478 # user to edit the combined commit message for all commits that have
479 # been squashed/fixedup so far.  So also erase the old squash
480 # messages, effectively causing the combined commit to be used as the
481 # new basis for any further squash/fixups.  Args: sha1 rest
482 die_failed_squash() {
483         sha1=$1
484         rest=$2
485         mv "$squash_msg" "$msg" || exit
486         rm -f "$fixup_msg"
487         cp "$msg" "$GIT_DIR"/MERGE_MSG || exit
488         warn
489         warn "$(eval_gettext "Could not apply \$sha1... \$rest")"
490         die_with_patch $sha1 ""
491 }
492
493 flush_rewritten_pending() {
494         test -s "$rewritten_pending" || return
495         newsha1="$(git rev-parse HEAD^0)"
496         sed "s/$/ $newsha1/" < "$rewritten_pending" >> "$rewritten_list"
497         rm -f "$rewritten_pending"
498 }
499
500 record_in_rewritten() {
501         oldsha1="$(git rev-parse $1)"
502         echo "$oldsha1" >> "$rewritten_pending"
503
504         case "$(peek_next_command)" in
505         squash|s|fixup|f)
506                 ;;
507         *)
508                 flush_rewritten_pending
509                 ;;
510         esac
511 }
512
513 do_pick () {
514         sha1=$1
515         rest=$2
516         if test "$(git rev-parse HEAD)" = "$squash_onto"
517         then
518                 # Set the correct commit message and author info on the
519                 # sentinel root before cherry-picking the original changes
520                 # without committing (-n).  Finally, update the sentinel again
521                 # to include these changes.  If the cherry-pick results in a
522                 # conflict, this means our behaviour is similar to a standard
523                 # failed cherry-pick during rebase, with a dirty index to
524                 # resolve before manually running git commit --amend then git
525                 # rebase --continue.
526                 git commit --allow-empty --allow-empty-message --amend \
527                            --no-post-rewrite -n -q -C $sha1 &&
528                         pick_one -n $sha1 &&
529                         git commit --allow-empty --allow-empty-message \
530                                    --amend --no-post-rewrite -n -q -C $sha1 \
531                                    ${gpg_sign_opt:+"$gpg_sign_opt"} ||
532                                    die_with_patch $sha1 "$(eval_gettext "Could not apply \$sha1... \$rest")"
533         else
534                 pick_one $sha1 ||
535                         die_with_patch $sha1 "$(eval_gettext "Could not apply \$sha1... \$rest")"
536         fi
537 }
538
539 do_next () {
540         rm -f "$msg" "$author_script" "$amend" "$state_dir"/stopped-sha || exit
541         read -r command sha1 rest < "$todo"
542         case "$command" in
543         "$comment_char"*|''|noop|drop|d)
544                 mark_action_done
545                 ;;
546         "$cr")
547                 # Work around CR left by "read" (e.g. with Git for Windows' Bash).
548                 mark_action_done
549                 ;;
550         pick|p)
551                 comment_for_reflog pick
552
553                 mark_action_done
554                 do_pick $sha1 "$rest"
555                 record_in_rewritten $sha1
556                 ;;
557         reword|r)
558                 comment_for_reflog reword
559
560                 mark_action_done
561                 do_pick $sha1 "$rest"
562                 git commit --amend --no-post-rewrite ${gpg_sign_opt:+"$gpg_sign_opt"} || {
563                         warn "$(eval_gettext "\
564 Could not amend commit after successfully picking \$sha1... \$rest
565 This is most likely due to an empty commit message, or the pre-commit hook
566 failed. If the pre-commit hook failed, you may need to resolve the issue before
567 you are able to reword the commit.")"
568                         exit_with_patch $sha1 1
569                 }
570                 record_in_rewritten $sha1
571                 ;;
572         edit|e)
573                 comment_for_reflog edit
574
575                 mark_action_done
576                 do_pick $sha1 "$rest"
577                 sha1_abbrev=$(git rev-parse --short $sha1)
578                 warn "$(eval_gettext "Stopped at \$sha1_abbrev... \$rest")"
579                 exit_with_patch $sha1 0
580                 ;;
581         squash|s|fixup|f)
582                 case "$command" in
583                 squash|s)
584                         squash_style=squash
585                         ;;
586                 fixup|f)
587                         squash_style=fixup
588                         ;;
589                 esac
590                 comment_for_reflog $squash_style
591
592                 test -f "$done" && has_action "$done" ||
593                         die "$(eval_gettext "Cannot '\$squash_style' without a previous commit")"
594
595                 mark_action_done
596                 update_squash_messages $squash_style $sha1
597                 author_script_content=$(get_author_ident_from_commit HEAD)
598                 echo "$author_script_content" > "$author_script"
599                 eval "$author_script_content"
600                 if ! pick_one -n $sha1
601                 then
602                         git rev-parse --verify HEAD >"$amend"
603                         die_failed_squash $sha1 "$rest"
604                 fi
605                 case "$(peek_next_command)" in
606                 squash|s|fixup|f)
607                         # This is an intermediate commit; its message will only be
608                         # used in case of trouble.  So use the long version:
609                         do_with_author output git commit --amend --no-verify -F "$squash_msg" \
610                                 ${gpg_sign_opt:+"$gpg_sign_opt"} ||
611                                 die_failed_squash $sha1 "$rest"
612                         ;;
613                 *)
614                         # This is the final command of this squash/fixup group
615                         if test -f "$fixup_msg"
616                         then
617                                 do_with_author git commit --amend --no-verify -F "$fixup_msg" \
618                                         ${gpg_sign_opt:+"$gpg_sign_opt"} ||
619                                         die_failed_squash $sha1 "$rest"
620                         else
621                                 cp "$squash_msg" "$GIT_DIR"/SQUASH_MSG || exit
622                                 rm -f "$GIT_DIR"/MERGE_MSG
623                                 do_with_author git commit --amend --no-verify -F "$GIT_DIR"/SQUASH_MSG -e \
624                                         ${gpg_sign_opt:+"$gpg_sign_opt"} ||
625                                         die_failed_squash $sha1 "$rest"
626                         fi
627                         rm -f "$squash_msg" "$fixup_msg"
628                         ;;
629                 esac
630                 record_in_rewritten $sha1
631                 ;;
632         x|"exec")
633                 read -r command rest < "$todo"
634                 mark_action_done
635                 eval_gettextln "Executing: \$rest"
636                 "${SHELL:-@SHELL_PATH@}" -c "$rest" # Actual execution
637                 status=$?
638                 # Run in subshell because require_clean_work_tree can die.
639                 dirty=f
640                 (require_clean_work_tree "rebase" 2>/dev/null) || dirty=t
641                 if test "$status" -ne 0
642                 then
643                         warn "$(eval_gettext "Execution failed: \$rest")"
644                         test "$dirty" = f ||
645                                 warn "$(gettext "and made changes to the index and/or the working tree")"
646
647                         warn "$(gettext "\
648 You can fix the problem, and then run
649
650         git rebase --continue")"
651                         warn
652                         if test $status -eq 127         # command not found
653                         then
654                                 status=1
655                         fi
656                         exit "$status"
657                 elif test "$dirty" = t
658                 then
659                         # TRANSLATORS: after these lines is a command to be issued by the user
660                         warn "$(eval_gettext "\
661 Execution succeeded: \$rest
662 but left changes to the index and/or the working tree
663 Commit or stash your changes, and then run
664
665         git rebase --continue")"
666                         warn
667                         exit 1
668                 fi
669                 ;;
670         *)
671                 warn "$(eval_gettext "Unknown command: \$command \$sha1 \$rest")"
672                 fixtodo="$(gettext "Please fix this using 'git rebase --edit-todo'.")"
673                 if git rev-parse --verify -q "$sha1" >/dev/null
674                 then
675                         die_with_patch $sha1 "$fixtodo"
676                 else
677                         die "$fixtodo"
678                 fi
679                 ;;
680         esac
681         test -s "$todo" && return
682
683         comment_for_reflog finish &&
684         newhead=$(git rev-parse HEAD) &&
685         case $head_name in
686         refs/*)
687                 message="$GIT_REFLOG_ACTION: $head_name onto $onto" &&
688                 git update-ref -m "$message" $head_name $newhead $orig_head &&
689                 git symbolic-ref \
690                   -m "$GIT_REFLOG_ACTION: returning to $head_name" \
691                   HEAD $head_name
692                 ;;
693         esac && {
694                 test ! -f "$state_dir"/verbose ||
695                         git diff-tree --stat $orig_head..HEAD
696         } &&
697         {
698                 test -s "$rewritten_list" &&
699                 git notes copy --for-rewrite=rebase < "$rewritten_list" ||
700                 true # we don't care if this copying failed
701         } &&
702         hook="$(git rev-parse --git-path hooks/post-rewrite)"
703         if test -x "$hook" && test -s "$rewritten_list"; then
704                 "$hook" rebase < "$rewritten_list"
705                 true # we don't care if this hook failed
706         fi &&
707                 warn "$(eval_gettext "Successfully rebased and updated \$head_name.")"
708
709         return 1 # not failure; just to break the do_rest loop
710 }
711
712 # can only return 0, when the infinite loop breaks
713 do_rest () {
714         while :
715         do
716                 do_next || break
717         done
718 }
719
720 expand_todo_ids() {
721         git rebase--helper --expand-ids
722 }
723
724 collapse_todo_ids() {
725         git rebase--helper --shorten-ids
726 }
727
728 # Switch to the branch in $into and notify it in the reflog
729 checkout_onto () {
730         GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: checkout $onto_name"
731         output git checkout $onto || die_abort "$(gettext "could not detach HEAD")"
732         git update-ref ORIG_HEAD $orig_head
733 }
734
735 get_missing_commit_check_level () {
736         check_level=$(git config --get rebase.missingCommitsCheck)
737         check_level=${check_level:-ignore}
738         # Don't be case sensitive
739         printf '%s' "$check_level" | tr 'A-Z' 'a-z'
740 }
741
742 # The whole contents of this file is run by dot-sourcing it from
743 # inside a shell function.  It used to be that "return"s we see
744 # below were not inside any function, and expected to return
745 # to the function that dot-sourced us.
746 #
747 # However, older (9.x) versions of FreeBSD /bin/sh misbehave on such a
748 # construct and continue to run the statements that follow such a "return".
749 # As a work-around, we introduce an extra layer of a function
750 # here, and immediately call it after defining it.
751 git_rebase__interactive () {
752
753 case "$action" in
754 continue)
755         if test ! -d "$rewritten"
756         then
757                 exec git rebase--helper ${force_rebase:+--no-ff} --continue
758         fi
759         # do we have anything to commit?
760         if git diff-index --cached --quiet HEAD --
761         then
762                 # Nothing to commit -- skip this commit
763
764                 test ! -f "$GIT_DIR"/CHERRY_PICK_HEAD ||
765                 rm "$GIT_DIR"/CHERRY_PICK_HEAD ||
766                 die "$(gettext "Could not remove CHERRY_PICK_HEAD")"
767         else
768                 if ! test -f "$author_script"
769                 then
770                         gpg_sign_opt_quoted=${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")}
771                         die "$(eval_gettext "\
772 You have staged changes in your working tree.
773 If these changes are meant to be
774 squashed into the previous commit, run:
775
776   git commit --amend \$gpg_sign_opt_quoted
777
778 If they are meant to go into a new commit, run:
779
780   git commit \$gpg_sign_opt_quoted
781
782 In both cases, once you're done, continue with:
783
784   git rebase --continue
785 ")"
786                 fi
787                 . "$author_script" ||
788                         die "$(gettext "Error trying to find the author identity to amend commit")"
789                 if test -f "$amend"
790                 then
791                         current_head=$(git rev-parse --verify HEAD)
792                         test "$current_head" = $(cat "$amend") ||
793                         die "$(gettext "\
794 You have uncommitted changes in your working tree. Please commit them
795 first and then run 'git rebase --continue' again.")"
796                         do_with_author git commit --amend --no-verify -F "$msg" -e \
797                                 ${gpg_sign_opt:+"$gpg_sign_opt"} ||
798                                 die "$(gettext "Could not commit staged changes.")"
799                 else
800                         do_with_author git commit --no-verify -F "$msg" -e \
801                                 ${gpg_sign_opt:+"$gpg_sign_opt"} ||
802                                 die "$(gettext "Could not commit staged changes.")"
803                 fi
804         fi
805
806         if test -r "$state_dir"/stopped-sha
807         then
808                 record_in_rewritten "$(cat "$state_dir"/stopped-sha)"
809         fi
810
811         require_clean_work_tree "rebase"
812         do_rest
813         return 0
814         ;;
815 skip)
816         git rerere clear
817
818         if test ! -d "$rewritten"
819         then
820                 exec git rebase--helper ${force_rebase:+--no-ff} --continue
821         fi
822         do_rest
823         return 0
824         ;;
825 edit-todo)
826         git stripspace --strip-comments <"$todo" >"$todo".new
827         mv -f "$todo".new "$todo"
828         collapse_todo_ids
829         append_todo_help
830         gettext "
831 You are editing the todo file of an ongoing interactive rebase.
832 To continue rebase after editing, run:
833     git rebase --continue
834
835 " | git stripspace --comment-lines >>"$todo"
836
837         git_sequence_editor "$todo" ||
838                 die "$(gettext "Could not execute editor")"
839         expand_todo_ids
840
841         exit
842         ;;
843 esac
844
845 comment_for_reflog start
846
847 if test ! -z "$switch_to"
848 then
849         GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: checkout $switch_to"
850         output git checkout "$switch_to" -- ||
851                 die "$(eval_gettext "Could not checkout \$switch_to")"
852
853         comment_for_reflog start
854 fi
855
856 orig_head=$(git rev-parse --verify HEAD) || die "$(gettext "No HEAD?")"
857 mkdir -p "$state_dir" || die "$(eval_gettext "Could not create temporary \$state_dir")"
858
859 : > "$state_dir"/interactive || die "$(gettext "Could not mark as interactive")"
860 write_basic_state
861 if test t = "$preserve_merges"
862 then
863         if test -z "$rebase_root"
864         then
865                 mkdir "$rewritten" &&
866                 for c in $(git merge-base --all $orig_head $upstream)
867                 do
868                         echo $onto > "$rewritten"/$c ||
869                                 die "$(gettext "Could not init rewritten commits")"
870                 done
871         else
872                 mkdir "$rewritten" &&
873                 echo $onto > "$rewritten"/root ||
874                         die "$(gettext "Could not init rewritten commits")"
875         fi
876         # No cherry-pick because our first pass is to determine
877         # parents to rewrite and skipping dropped commits would
878         # prematurely end our probe
879         merges_option=
880 else
881         merges_option="--no-merges --cherry-pick"
882 fi
883
884 shorthead=$(git rev-parse --short $orig_head)
885 shortonto=$(git rev-parse --short $onto)
886 if test -z "$rebase_root"
887         # this is now equivalent to ! -z "$upstream"
888 then
889         shortupstream=$(git rev-parse --short $upstream)
890         revisions=$upstream...$orig_head
891         shortrevisions=$shortupstream..$shorthead
892 else
893         revisions=$onto...$orig_head
894         shortrevisions=$shorthead
895 fi
896 if test t != "$preserve_merges"
897 then
898         git rebase--helper --make-script ${keep_empty:+--keep-empty} \
899                 $revisions ${restrict_revision+^$restrict_revision} >"$todo" ||
900         die "$(gettext "Could not generate todo list")"
901 else
902         format=$(git config --get rebase.instructionFormat)
903         # the 'rev-list .. | sed' requires %m to parse; the instruction requires %H to parse
904         git rev-list $merges_option --format="%m%H ${format:-%s}" \
905                 --reverse --left-right --topo-order \
906                 $revisions ${restrict_revision+^$restrict_revision} | \
907                 sed -n "s/^>//p" |
908         while read -r sha1 rest
909         do
910
911                 if test -z "$keep_empty" && is_empty_commit $sha1 && ! is_merge_commit $sha1
912                 then
913                         comment_out="$comment_char "
914                 else
915                         comment_out=
916                 fi
917
918                 if test -z "$rebase_root"
919                 then
920                         preserve=t
921                         for p in $(git rev-list --parents -1 $sha1 | cut -d' ' -s -f2-)
922                         do
923                                 if test -f "$rewritten"/$p
924                                 then
925                                         preserve=f
926                                 fi
927                         done
928                 else
929                         preserve=f
930                 fi
931                 if test f = "$preserve"
932                 then
933                         touch "$rewritten"/$sha1
934                         printf '%s\n' "${comment_out}pick $sha1 $rest" >>"$todo"
935                 fi
936         done
937 fi
938
939 # Watch for commits that been dropped by --cherry-pick
940 if test t = "$preserve_merges"
941 then
942         mkdir "$dropped"
943         # Save all non-cherry-picked changes
944         git rev-list $revisions --left-right --cherry-pick | \
945                 sed -n "s/^>//p" > "$state_dir"/not-cherry-picks
946         # Now all commits and note which ones are missing in
947         # not-cherry-picks and hence being dropped
948         git rev-list $revisions |
949         while read rev
950         do
951                 if test -f "$rewritten"/$rev &&
952                    ! sane_grep "$rev" "$state_dir"/not-cherry-picks >/dev/null
953                 then
954                         # Use -f2 because if rev-list is telling us this commit is
955                         # not worthwhile, we don't want to track its multiple heads,
956                         # just the history of its first-parent for others that will
957                         # be rebasing on top of it
958                         git rev-list --parents -1 $rev | cut -d' ' -s -f2 > "$dropped"/$rev
959                         sha1=$(git rev-list -1 $rev)
960                         sane_grep -v "^[a-z][a-z]* $sha1" <"$todo" > "${todo}2" ; mv "${todo}2" "$todo"
961                         rm "$rewritten"/$rev
962                 fi
963         done
964 fi
965
966 test -s "$todo" || echo noop >> "$todo"
967 test -z "$autosquash" || git rebase--helper --rearrange-squash || exit
968 test -n "$cmd" && git rebase--helper --add-exec-commands "$cmd"
969
970 todocount=$(git stripspace --strip-comments <"$todo" | wc -l)
971 todocount=${todocount##* }
972
973 cat >>"$todo" <<EOF
974
975 $comment_char $(eval_ngettext \
976         "Rebase \$shortrevisions onto \$shortonto (\$todocount command)" \
977         "Rebase \$shortrevisions onto \$shortonto (\$todocount commands)" \
978         "$todocount")
979 EOF
980 append_todo_help
981 gettext "
982 However, if you remove everything, the rebase will be aborted.
983
984 " | git stripspace --comment-lines >>"$todo"
985
986 if test -z "$keep_empty"
987 then
988         printf '%s\n' "$comment_char $(gettext "Note that empty commits are commented out")" >>"$todo"
989 fi
990
991
992 has_action "$todo" ||
993         return 2
994
995 cp "$todo" "$todo".backup
996 collapse_todo_ids
997 git_sequence_editor "$todo" ||
998         die_abort "$(gettext "Could not execute editor")"
999
1000 has_action "$todo" ||
1001         return 2
1002
1003 git rebase--helper --check-todo-list || {
1004         ret=$?
1005         checkout_onto
1006         exit $ret
1007 }
1008
1009 expand_todo_ids
1010
1011 test -d "$rewritten" || test -n "$force_rebase" ||
1012 onto="$(git rebase--helper --skip-unnecessary-picks)" ||
1013 die "Could not skip unnecessary pick commands"
1014
1015 checkout_onto
1016 if test -z "$rebase_root" && test ! -d "$rewritten"
1017 then
1018         require_clean_work_tree "rebase"
1019         exec git rebase--helper ${force_rebase:+--no-ff} --continue
1020 fi
1021 do_rest
1022
1023 }
1024 # ... and then we call the whole thing.
1025 git_rebase__interactive